From a54226f222fd52c1587594c73b3ebb9499c77dc5 Mon Sep 17 00:00:00 2001
From: Rafia Sabih <rafia.sabih@cybertec.at>
Date: Wed, 15 Jul 2026 16:51:16 +0530
Subject: [PATCH v13 2/2] postgres_fdw:Add streaming_fetch option for
 cursor-free fetching

postgres_fdw uses cursors to fetch tuples from the remote server
incrementally. While this works correctly, cursors prevent the remote
side from using parallel query execution, which can significantly limit
performance for large scans.

This adds a new boolean option streaming_fetch, available at both the
server and table level, that gives an alternate fetching mechanism.
Because no cursor is created on the remote side, the remote query is free
to use parallel execution.

When a second scan begins on the same connection while another is still
in progress, the remaining tuples of the active scan are drained into a
tuplestore and replayed when execution returns to that scan. This
preserves correct results across nested or interleaved scans without
requiring an additional connection.

streaming_fetch defaults to false, preserving existing behavior.
Asynchronous execution is not supported in this mode and is disabled
automatically when streaming_fetch is enabled.

Original idea: Bernd Helmle
Key suggestions: Robert Haas
---
 contrib/postgres_fdw/connection.c             |  21 +-
 .../postgres_fdw/expected/postgres_fdw.out    | 986 +++++++++++++++++-
 contrib/postgres_fdw/option.c                 |   4 +
 contrib/postgres_fdw/postgres_fdw.c           | 463 +++++++-
 contrib/postgres_fdw/postgres_fdw.h           |   7 +
 contrib/postgres_fdw/sql/postgres_fdw.sql     | 410 ++++++++
 doc/src/sgml/postgres-fdw.sgml                |  15 +
 7 files changed, 1857 insertions(+), 49 deletions(-)

diff --git a/contrib/postgres_fdw/connection.c b/contrib/postgres_fdw/connection.c
index aab21695979..2b298bd2a91 100644
--- a/contrib/postgres_fdw/connection.c
+++ b/contrib/postgres_fdw/connection.c
@@ -163,7 +163,6 @@ static void pgfdw_inval_callback(Datum arg, SysCacheIdentifier cacheid,
 								 uint32 hashvalue);
 static void pgfdw_reject_incomplete_xact_state_change(ConnCacheEntry *entry);
 static void pgfdw_reset_xact_state(ConnCacheEntry *entry, bool toplevel);
-static bool pgfdw_cancel_query(PGconn *conn);
 static bool pgfdw_cancel_query_begin(PGconn *conn, TimestampTz endtime);
 static bool pgfdw_cancel_query_end(PGconn *conn, TimestampTz endtime,
 								   TimestampTz retrycanceltime,
@@ -1090,6 +1089,16 @@ pgfdw_get_result(PGconn *conn)
 	return libpqsrv_get_result_last(conn, pgfdw_we_get_result);
 }
 
+/*
+ * Used in case of streaming_fetch mode.
+ * Caller is responsible for the error handling on the result.
+ */
+PGresult *
+pgfdw_get_next_result(PGconn *conn)
+{
+	return libpqsrv_get_result(conn, pgfdw_we_get_result);
+}
+
 /*
  * Report an error we got from the remote server.
  *
@@ -1567,7 +1576,7 @@ pgfdw_reset_xact_state(ConnCacheEntry *entry, bool toplevel)
  * query text from the pendingAreq saved in the per-connection state, then
  * report the query using it.
  */
-static bool
+bool
 pgfdw_cancel_query(PGconn *conn)
 {
 	TimestampTz now = GetCurrentTimestamp();
@@ -1927,8 +1936,10 @@ pgfdw_abort_cleanup(ConnCacheEntry *entry, bool toplevel)
 	 * an asynchronous fetch begun by fetch_more_data_begin() was not done
 	 * successfully and thus the per-connection state was not reset in
 	 * fetch_more_data(); in that case reset the per-connection state here.
+	 * Similarly for active_scan, if it is not consumed completely then reset
+	 * the state here.
 	 */
-	if (entry->state.pendingAreq)
+	if (entry->state.pendingAreq || entry->state.active_scan)
 		memset(&entry->state, 0, sizeof(entry->state));
 
 	/* Disarm changing_xact_state if it all worked */
@@ -2219,7 +2230,7 @@ pgfdw_finish_abort_cleanup(List *pending_entries, List *cancel_requested,
 		}
 
 		/* Reset the per-connection state if needed */
-		if (entry->state.pendingAreq)
+		if (entry->state.pendingAreq || entry->state.active_scan)
 			memset(&entry->state, 0, sizeof(entry->state));
 
 		/* We're done with this entry; unset the changing_xact_state flag */
@@ -2264,7 +2275,7 @@ pgfdw_finish_abort_cleanup(List *pending_entries, List *cancel_requested,
 		entry->have_error = false;
 
 		/* Reset the per-connection state if needed */
-		if (entry->state.pendingAreq)
+		if (entry->state.pendingAreq || entry->state.active_scan)
 			memset(&entry->state, 0, sizeof(entry->state));
 
 		/* We're done with this entry; unset the changing_xact_state flag */
diff --git a/contrib/postgres_fdw/option.c b/contrib/postgres_fdw/option.c
index 79b16c3f318..bd702523fe4 100644
--- a/contrib/postgres_fdw/option.c
+++ b/contrib/postgres_fdw/option.c
@@ -121,6 +121,7 @@ postgres_fdw_validator(PG_FUNCTION_ARGS)
 			strcmp(def->defname, "parallel_commit") == 0 ||
 			strcmp(def->defname, "parallel_abort") == 0 ||
 			strcmp(def->defname, "keep_connections") == 0 ||
+			strcmp(def->defname, "streaming_fetch") == 0 ||
 			strcmp(def->defname, "restore_stats") == 0 ||
 			strcmp(def->defname, "use_scram_passthrough") == 0)
 		{
@@ -262,6 +263,9 @@ InitPgFdwOptions(void)
 		/* fetch_size is available on both server and table */
 		{"fetch_size", ForeignServerRelationId, false},
 		{"fetch_size", ForeignTableRelationId, false},
+		/* streaming_fetch is available on both server and table */
+		{"streaming_fetch", ForeignServerRelationId, false},
+		{"streaming_fetch", ForeignTableRelationId, false},
 		/* batch_size is available on both server and table */
 		{"batch_size", ForeignServerRelationId, false},
 		{"batch_size", ForeignTableRelationId, false},
diff --git a/contrib/postgres_fdw/postgres_fdw.c b/contrib/postgres_fdw/postgres_fdw.c
index 3546c1217f9..5e3ef5b8483 100644
--- a/contrib/postgres_fdw/postgres_fdw.c
+++ b/contrib/postgres_fdw/postgres_fdw.c
@@ -54,6 +54,7 @@
 #include "utils/sampling.h"
 #include "utils/selfuncs.h"
 #include "utils/timestamp.h"
+#include "utils/tuplestore.h"
 
 PG_MODULE_MAGIC_EXT(
 					.name = "postgres_fdw",
@@ -84,6 +85,8 @@ enum FdwScanPrivateIndex
 	FdwScanPrivateRetrievedAttrs,
 	/* Integer representing the desired fetch_size */
 	FdwScanPrivateFetchSize,
+	/* Boolean indicating whether streaming_fetch mode is enabled */
+	FdwScanPrivateStreamingFetch,
 
 	/*
 	 * String describing join i.e. names of relations being joined and types
@@ -180,6 +183,12 @@ typedef struct PgFdwScanState
 	MemoryContext temp_cxt;		/* context for per-tuple temporary data */
 
 	int			fetch_size;		/* number of tuples per fetch */
+	/* Required for the streaming_fetch mode */
+	bool		streaming_fetch;	/* set if the scan is using
+									 * streaming_fetch mode */
+	Tuplestorestate *tuplestore;	/* Tuplestore to save the tuples of the
+									 * query for later fetch. */
+	ForeignScanState *fsnode;	/* back-pointer, used by save_to_tuplestore */
 } PgFdwScanState;
 
 /*
@@ -639,6 +648,14 @@ static void merge_fdw_options(PgFdwRelationInfo *fpinfo,
 							  const PgFdwRelationInfo *fpinfo_i);
 static int	get_batch_size_option(Relation rel);
 
+/* Only required for non-cursor mode */
+static void set_streaming_fetch(DefElem *def, PgFdwRelationInfo *fpinfo);
+static void drain_other_active_scan(PgFdwConnState *conn_state, PGconn *conn,
+									PgFdwScanState *self);
+static void fetch_from_tuplestore(ForeignScanState *node);
+static void save_to_tuplestore(PgFdwScanState *fsstate, PGconn *conn);
+static void init_scan(ForeignScanState *node);
+static bool is_active_scan(PgFdwScanState *fsstate);
 
 /*
  * Foreign-data wrapper handler function: return a struct with pointers
@@ -748,9 +765,12 @@ postgresGetForeignRelSize(PlannerInfo *root,
 	fpinfo->shippable_extensions = NIL;
 	fpinfo->fetch_size = 100;
 	fpinfo->async_capable = false;
+	fpinfo->streaming_fetch = false;
 
 	apply_server_options(fpinfo);
 	apply_table_options(fpinfo);
+	if (fpinfo->streaming_fetch)
+		fpinfo->async_capable = false;
 
 	/*
 	 * If the table or the server is configured to use remote estimates,
@@ -1510,9 +1530,9 @@ postgresGetForeignPlan(PlannerInfo *root,
 	 * Build the fdw_private list that will be available to the executor.
 	 * Items in the list must match order in enum FdwScanPrivateIndex.
 	 */
-	fdw_private = list_make3(makeString(sql.data),
+	fdw_private = list_make4(makeString(sql.data),
 							 retrieved_attrs,
-							 makeInteger(fpinfo->fetch_size));
+							 makeInteger(fpinfo->fetch_size), makeBoolean(fpinfo->streaming_fetch));
 	if (IS_JOIN_REL(foreignrel) || IS_UPPER_REL(foreignrel))
 		fdw_private = lappend(fdw_private,
 							  makeString(fpinfo->relation_name));
@@ -1646,6 +1666,8 @@ postgresBeginForeignScan(ForeignScanState *node, int eflags)
 												 FdwScanPrivateRetrievedAttrs);
 	fsstate->fetch_size = intVal(list_nth(fsplan->fdw_private,
 										  FdwScanPrivateFetchSize));
+	fsstate->streaming_fetch = boolVal(list_nth(fsplan->fdw_private,
+												FdwScanPrivateStreamingFetch));
 
 	/* Create contexts for batches of tuples and per-tuple temp workspace. */
 	fsstate->batch_cxt = AllocSetContextCreate(estate->es_query_cxt,
@@ -1687,6 +1709,8 @@ postgresBeginForeignScan(ForeignScanState *node, int eflags)
 
 	/* Set the async-capable flag */
 	fsstate->async_capable = node->ss.ps.async_capable;
+	fsstate->tuplestore = NULL;
+	fsstate->fsnode = node;
 }
 
 /*
@@ -1707,7 +1731,12 @@ postgresIterateForeignScan(ForeignScanState *node)
 	 * first call after Begin or ReScan.
 	 */
 	if (!fsstate->scan_in_progress)
-		create_cursor(node);
+	{
+		if (fsstate->streaming_fetch)
+			init_scan(node);
+		else
+			create_cursor(node);
+	}
 
 	/*
 	 * Get some more tuples, if we've run out.
@@ -1744,7 +1773,8 @@ postgresReScanForeignScan(ForeignScanState *node)
 {
 	PgFdwScanState *fsstate = (PgFdwScanState *) node->fdw_state;
 	char		sql[64];
-	PGresult   *res;
+	PGresult   *res = NULL;
+	bool		reinitialize_scan = false;
 
 	/* If no scan is in progress, nothing to do. */
 	if (!fsstate->scan_in_progress)
@@ -1773,40 +1803,82 @@ postgresReScanForeignScan(ForeignScanState *node)
 	 */
 	if (node->ss.ps.chgParam != NULL)
 	{
-		fsstate->scan_in_progress = false;
-		snprintf(sql, sizeof(sql), "CLOSE c%u",
-				 fsstate->cursor_number);
+		reinitialize_scan = true;
 	}
 	else if (fsstate->fetch_ct_2 > 1)
 	{
-		if (PQserverVersion(fsstate->conn) < 150000)
+		if (!fsstate->streaming_fetch && PQserverVersion(fsstate->conn) < 150000)
+		{
+			drain_other_active_scan(fsstate->conn_state, fsstate->conn, fsstate);
 			snprintf(sql, sizeof(sql), "MOVE BACKWARD ALL IN c%u",
 					 fsstate->cursor_number);
+			res = pgfdw_exec_query(fsstate->conn, sql, fsstate->conn_state);
+			if (PQresultStatus(res) != PGRES_COMMAND_OK)
+				pgfdw_report_error(res, fsstate->conn, sql);
+
+			PQclear(res);
+
+			/* Now force a fresh FETCH. */
+			fsstate->tuples = NULL;
+			fsstate->num_tuples = 0;
+			fsstate->next_tuple = 0;
+			fsstate->fetch_ct_2 = 0;
+			fsstate->eof_reached = false;
+			return;
+		}
+		else
+			reinitialize_scan = true;
+	}
+	else
+	{
+		/*
+		 * Easy: just rescan what we already have in memory, if anything.
+		 *
+		 * Exception: in streaming_fetch mode a populated tuplestore holds
+		 * rows drained from a previous pass; those cannot be rewound to the
+		 * start, so we must reinitialise the scan from scratch.
+		 */
+		if (fsstate->streaming_fetch && fsstate->tuplestore)
+			reinitialize_scan = true;
 		else
 		{
-			fsstate->scan_in_progress = false;
-			snprintf(sql, sizeof(sql), "CLOSE c%u",
-					 fsstate->cursor_number);
+			fsstate->next_tuple = 0;
+			return;
 		}
 	}
-	else
+	if (reinitialize_scan)
 	{
-		/* Easy: just rescan what we already have in memory, if anything */
+		if (fsstate->streaming_fetch)
+		{
+			if (is_active_scan(fsstate))
+			{
+				fsstate->conn_state->active_scan = NULL;
+				pgfdw_cancel_query(fsstate->conn);
+			}
+			if (fsstate->tuplestore)
+			{
+				tuplestore_end(fsstate->tuplestore);
+				fsstate->tuplestore = NULL;
+			}
+		}
+		else
+		{
+			drain_other_active_scan(fsstate->conn_state, fsstate->conn, fsstate);
+			snprintf(sql, sizeof(sql), "CLOSE c%u",
+					 fsstate->cursor_number);
+			res = pgfdw_exec_query(fsstate->conn, sql, fsstate->conn_state);
+			if (PQresultStatus(res) != PGRES_COMMAND_OK)
+				pgfdw_report_error(res, fsstate->conn, sql);
+			PQclear(res);
+		}
+		/* Now force a fresh FETCH. */
+		fsstate->tuples = NULL;
+		fsstate->num_tuples = 0;
 		fsstate->next_tuple = 0;
-		return;
+		fsstate->fetch_ct_2 = 0;
+		fsstate->eof_reached = false;
+		fsstate->scan_in_progress = false;
 	}
-
-	res = pgfdw_exec_query(fsstate->conn, sql, fsstate->conn_state);
-	if (PQresultStatus(res) != PGRES_COMMAND_OK)
-		pgfdw_report_error(res, fsstate->conn, sql);
-	PQclear(res);
-
-	/* Now force a fresh FETCH. */
-	fsstate->tuples = NULL;
-	fsstate->num_tuples = 0;
-	fsstate->next_tuple = 0;
-	fsstate->fetch_ct_2 = 0;
-	fsstate->eof_reached = false;
 }
 
 /*
@@ -1824,9 +1896,27 @@ postgresEndForeignScan(ForeignScanState *node)
 
 	/* Close the cursor if open, to prevent accumulation of cursors */
 	if (fsstate->scan_in_progress)
-		close_cursor(fsstate->conn, fsstate->cursor_number,
-					 fsstate->conn_state);
+	{
+		if (fsstate->streaming_fetch)
+		{
+			/* Remove the pointer from conn_state since ending this scan. */
+			if (is_active_scan(fsstate))
+			{
+				fsstate->conn_state->active_scan = NULL;
+				pgfdw_cancel_query(fsstate->conn);
+			}
+			if (fsstate->tuplestore)
+				tuplestore_end(fsstate->tuplestore);
 
+			MemoryContextReset(fsstate->batch_cxt);
+		}
+		else
+		{
+			drain_other_active_scan(fsstate->conn_state, fsstate->conn, fsstate);
+			close_cursor(fsstate->conn, fsstate->cursor_number,
+						 fsstate->conn_state);
+		}
+	}
 	/* Release remote connection */
 	ReleaseConnection(fsstate->conn);
 	fsstate->conn = NULL;
@@ -3017,9 +3107,13 @@ postgresExplainForeignScan(ForeignScanState *node, ExplainState *es)
 	if (es->verbose)
 	{
 		char	   *sql;
+		bool		stream_fetch;
 
 		sql = strVal(list_nth(fdw_private, FdwScanPrivateSelectSql));
+		stream_fetch = boolVal(list_nth(fdw_private, FdwScanPrivateStreamingFetch));
 		ExplainPropertyText("Remote SQL", sql, es);
+		if (stream_fetch)
+			ExplainPropertyBool("streaming_fetch", stream_fetch, es);
 	}
 }
 
@@ -3830,6 +3924,12 @@ create_cursor(ForeignScanState *node)
 	if (fsstate->conn_state->pendingAreq)
 		process_pending_request(fsstate->conn_state->pendingAreq);
 
+	/*
+	 * If the other scan_in_progress is using streaming_fetch mode, then save
+	 * the tuples to tuplestore before creating this cursor.
+	 */
+	drain_other_active_scan(fsstate->conn_state, fsstate->conn, fsstate);
+
 	/*
 	 * Construct array of query parameter values in text format.  We do the
 	 * conversions in the short-lived per-tuple context, so as not to cause a
@@ -3885,6 +3985,70 @@ create_cursor(ForeignScanState *node)
 	pfree(buf.data);
 }
 
+static void
+init_scan(ForeignScanState *node)
+{
+	PgFdwScanState *fsstate = (PgFdwScanState *) node->fdw_state;
+	ExprContext *econtext = node->ss.ps.ps_ExprContext;
+	int			numParams = fsstate->numParams;
+	const char **values = fsstate->param_values;
+	PGconn	   *conn = fsstate->conn;
+
+	/* First, process a pending asynchronous request, if any. */
+	if (fsstate->conn_state->pendingAreq)
+		process_pending_request(fsstate->conn_state->pendingAreq);
+
+	/*
+	 * Construct array of query parameter values in text format.  We do the
+	 * conversions in the short-lived per-tuple context, so as not to cause a
+	 * memory leak over repeated scans.
+	 */
+	if (numParams > 0)
+	{
+		MemoryContext oldcontext;
+
+		oldcontext = MemoryContextSwitchTo(econtext->ecxt_per_tuple_memory);
+
+		process_query_params(econtext,
+							 fsstate->param_flinfo,
+							 fsstate->param_exprs,
+							 values);
+
+		MemoryContextSwitchTo(oldcontext);
+	}
+
+	/*
+	 * Finish fetching tuples of the last query.
+	 */
+	drain_other_active_scan(fsstate->conn_state, fsstate->conn, fsstate);
+
+	if (!PQsendQueryParams(conn, fsstate->query, numParams,
+						   NULL, values, NULL, NULL, 0))
+		pgfdw_report_error(NULL, conn, fsstate->query);
+
+	/*
+	 * Call for Chunked rows mode with same size of chunk as the fetch size
+	 */
+	if (!PQsetChunkedRowsMode(conn, fsstate->fetch_size))
+	{
+		pgfdw_cancel_query(fsstate->conn);
+		pgfdw_report_error(NULL, conn, fsstate->query);
+	}
+
+	fsstate->tuples = NULL;
+	fsstate->num_tuples = 0;
+	fsstate->next_tuple = 0;
+	fsstate->fetch_ct_2 = 0;
+	fsstate->eof_reached = false;
+
+	/*
+	 * To remember the current scan as the last one, when control switches to
+	 * another scan
+	 */
+	fsstate->conn_state->active_scan = fsstate;
+	fsstate->scan_in_progress = true;
+}
+
 /*
  * Fetch some more rows from the node's cursor.
  */
@@ -3894,14 +4058,10 @@ fetch_more_data(ForeignScanState *node)
 	PgFdwScanState *fsstate = (PgFdwScanState *) node->fdw_state;
 	PGconn	   *conn = fsstate->conn;
 	PGresult   *res;
-	int			numrows;
-	int			i;
+	int			numrows = 0,
+				i = 0;
 	MemoryContext oldcontext;
 
-	/*
-	 * We'll store the tuples in the batch_cxt.  First, flush the previous
-	 * batch.
-	 */
 	fsstate->tuples = NULL;
 	MemoryContextReset(fsstate->batch_cxt);
 	oldcontext = MemoryContextSwitchTo(fsstate->batch_cxt);
@@ -3922,7 +4082,7 @@ fetch_more_data(ForeignScanState *node)
 		/* Reset per-connection state */
 		fsstate->conn_state->pendingAreq = NULL;
 	}
-	else
+	else if (!fsstate->streaming_fetch)
 	{
 		char		sql[64];
 
@@ -3935,7 +4095,50 @@ fetch_more_data(ForeignScanState *node)
 		if (PQresultStatus(res) != PGRES_TUPLES_OK)
 			pgfdw_report_error(res, conn, fsstate->query);
 	}
+	else
+	{
+		/*
+		 * When cursor mode is not used, there is a special possibility --
+		 * reading from the tuplestore. For processing of tuples nothing
+		 * changes in cursor and mode without cursor during fetch.
+		 */
+		if (fsstate->tuplestore)
+		{
+			/* Reading tuples from tuplestore */
+			fetch_from_tuplestore(node);
+			MemoryContextSwitchTo(oldcontext);
+			return;
+		}
 
+		/*
+		 * Non-cursor mode uses PQSetChunkedRowsMode during init_scan, so just
+		 * get the result here.
+		 */
+		res = pgfdw_get_next_result(conn);
+
+		if (!res || PQresultStatus(res) == PGRES_FATAL_ERROR)
+			pgfdw_report_error(res, conn, fsstate->query);
+
+		/*
+		 * PGRES_TUPLES_OK is the end-of-stream sentinel in chunked mode.
+		 * Consume the trailing protocol NULL now and clear active_scan so a
+		 * concurrent init_scan does not call save_to_tuplestore on an
+		 * already-idle connection.
+		 */
+		if (PQresultStatus(res) == PGRES_TUPLES_OK)
+		{
+			Assert(PQntuples(res) == 0);
+			PQclear(res);
+			res = pgfdw_get_next_result(conn);
+			if (res != NULL)
+				pgfdw_report_error(res, conn, fsstate->query);
+			fsstate->conn_state->active_scan = NULL;
+			fsstate->eof_reached = true;
+			MemoryContextSwitchTo(oldcontext);
+			return;
+		}
+
+	}
 	/* Convert the data into HeapTuples */
 	numrows = PQntuples(res);
 	fsstate->tuples = (HeapTuple *) palloc0(numrows * sizeof(HeapTuple));
@@ -3964,9 +4167,166 @@ fetch_more_data(ForeignScanState *node)
 
 	PQclear(res);
 
+	/*
+	 * In streaming_fetch mode, a partial chunk signals EOF, but TUPLES_OK and
+	 * the protocol NULL are still pending.  Drain them now so the connection
+	 * is immediately reusable and active_scan is cleared.
+	 */
+	if (fsstate->streaming_fetch && fsstate->eof_reached)
+	{
+		PGresult   *tail = pgfdw_get_next_result(conn);
+
+		if (tail && PQresultStatus(tail) == PGRES_TUPLES_OK)
+		{
+			PQclear(tail);
+			tail = pgfdw_get_next_result(conn);
+		}
+		if (tail != NULL)
+			pgfdw_report_error(tail, conn, fsstate->query);
+
+		fsstate->conn_state->active_scan = NULL;
+	}
+
 	MemoryContextSwitchTo(oldcontext);
 }
 
+static bool
+is_active_scan(PgFdwScanState *fsstate)
+{
+	if (fsstate->streaming_fetch && fsstate->conn_state->active_scan &&
+		fsstate == fsstate->conn_state->active_scan)
+		return true;
+	return false;
+}
+
+/*
+ * This is used in streaming_fetch mode only to fetch the tuples from the tuplestore.
+ */
+static void
+fetch_from_tuplestore(ForeignScanState *node)
+{
+	PgFdwScanState *fsstate = (PgFdwScanState *) node->fdw_state;
+	TupleTableSlot *slot;
+	int			numrows = 0,
+				i = 0;
+
+	/* Retrieve the tuples from the tuplestore instead of actual fetch */
+	numrows = tuplestore_tuple_count(fsstate->tuplestore);
+	fsstate->tuples = (HeapTuple *) palloc0(numrows * sizeof(HeapTuple));
+	slot = MakeSingleTupleTableSlot(fsstate->tupdesc, &TTSOpsMinimalTuple);
+
+	while (tuplestore_gettupleslot(fsstate->tuplestore, true, true, slot))
+	{
+		fsstate->tuples[i++] = ExecFetchSlotHeapTuple(slot, true, NULL);
+		ExecClearTuple(slot);
+	}
+	fsstate->num_tuples = numrows;
+	fsstate->next_tuple = 0;
+	fsstate->eof_reached = true;
+
+	/* Clean up */
+	tuplestore_end(fsstate->tuplestore);
+	ExecDropSingleTupleTableSlot(slot);
+	fsstate->tuplestore = NULL;
+}
+
+/*
+ * If another scan on this connection is a streaming_fetch scan that still
+ * has results in flight, drain them into its tuplestore before we send any
+ * command of our own — otherwise PQsendQuery() will fail because the
+ * connection already has an outstanding, unconsumed result.
+ */
+static void
+drain_other_active_scan(PgFdwConnState *conn_state, PGconn *conn,
+						PgFdwScanState *self)
+{
+	if (conn_state->active_scan && conn_state->active_scan != self)
+		save_to_tuplestore(conn_state->active_scan, conn);
+}
+
+/*
+ * In non-cursor mode only, save the tuples to tuplestore.
+ */
+static void
+save_to_tuplestore(PgFdwScanState *active_fsstate, PGconn *conn)
+{
+	PGresult   *res = NULL;
+	int			numrows = 0,
+				i = 0;
+	MemoryContext oldcontext;
+
+	oldcontext = MemoryContextSwitchTo(MemoryContextGetParent(active_fsstate->batch_cxt));
+
+	res = pgfdw_get_next_result(conn);
+
+	if (!res || PQresultStatus(res) == PGRES_FATAL_ERROR)
+		pgfdw_report_error(res, conn, active_fsstate->query);
+	else if (PQresultStatus(res) == PGRES_TUPLES_OK)
+	{
+		/*
+		 * This signifies there is nothing todo, all is fetched. But this
+		 * happened only after this call, so set the eof_reached for the scan.
+		 */
+		active_fsstate->eof_reached = true;
+		Assert(PQntuples(res) == 0);
+		PQclear(res);
+	}
+	else if (PQresultStatus(res) == PGRES_TUPLES_CHUNK)
+	{
+		active_fsstate->tuplestore = tuplestore_begin_heap(true, false, work_mem);
+
+		for (;;)
+		{
+			/*
+			 * Since it is using PQSetChunkedRowsMode, we only get the
+			 * fsstate->fetch_size tuples in one run, so keep on executing
+			 * till we get NULL in PGresult i.e. all the tuples are retrieved.
+			 */
+			CHECK_FOR_INTERRUPTS();
+			numrows = PQntuples(res);
+
+			/* Convert the data into HeapTuples */
+			for (i = 0; i < numrows; i++)
+			{
+				HeapTuple	temp_tuple;
+
+				temp_tuple = make_tuple_from_result_row(res, i,
+														active_fsstate->rel,
+														active_fsstate->attinmeta,
+														active_fsstate->retrieved_attrs,
+														active_fsstate->fsnode,
+														active_fsstate->temp_cxt);
+				tuplestore_puttuple(active_fsstate->tuplestore, temp_tuple);
+				heap_freetuple(temp_tuple);
+			}
+			PQclear(res);
+			res = pgfdw_get_next_result(conn);
+			if (res == NULL || PQresultStatus(res) == PGRES_FATAL_ERROR)
+				pgfdw_report_error(res, conn, active_fsstate->query);
+			else if (PQresultStatus(res) == PGRES_TUPLES_OK)
+			{
+				Assert(PQntuples(res) == 0);
+				PQclear(res);
+				break;
+			}
+		}
+	}
+
+	/*
+	 * There are no more tuples to fetch, a final call to reach the terminal
+	 * state.
+	 */
+	res = pgfdw_get_next_result(conn);
+	Assert(res == NULL);
+	MemoryContextSwitchTo(oldcontext);
+
+	/*
+	 * The connection is now idle again; let other scans on this connection
+	 * resume using it.
+	 */
+	active_fsstate->conn_state->active_scan = NULL;
+}
+
 /*
  * Force assorted GUC parameters to settings that ensure that we'll output
  * data values in a form that is unambiguous to the remote server.
@@ -4236,6 +4596,12 @@ execute_foreign_modify(EState *estate,
 	/* Convert parameters needed by prepared statement to text form */
 	p_values = convert_prep_stmt_params(fmstate, ctid, slots, *numSlots);
 
+	/*
+	 * If the other scan_in_progress is using streaming_fetch mode, then save
+	 * the tuples to tuplestore before proceeding further.
+	 */
+	drain_other_active_scan(fmstate->conn_state, fmstate->conn, NULL);
+
 	/*
 	 * Execute the prepared statement.
 	 */
@@ -4626,6 +4992,12 @@ execute_dml_stmt(ForeignScanState *node)
 							 dmstate->param_exprs,
 							 values);
 
+	/*
+	 * If the other scan_in_progress is using streaming_fetch mode, then save
+	 * the tuples to tuplestore before proceeding further.
+	 */
+	drain_other_active_scan(dmstate->conn_state, dmstate->conn, NULL);
+
 	/*
 	 * Notice that we pass NULL for paramTypes, thus forcing the remote server
 	 * to infer types for all parameters.  Since we explicitly cast every
@@ -5334,7 +5706,7 @@ postgresAcquireSampleRowsFunc(Relation relation, int elevel,
 	for (;;)
 	{
 		int			numrows;
-		int			i;
+		int			i = 0;
 
 		/* Allow users to cancel long query */
 		CHECK_FOR_INTERRUPTS();
@@ -7043,6 +7415,8 @@ apply_server_options(PgFdwRelationInfo *fpinfo)
 			(void) parse_int(defGetString(def), &fpinfo->fetch_size, 0, NULL);
 		else if (strcmp(def->defname, "async_capable") == 0)
 			fpinfo->async_capable = defGetBoolean(def);
+		else if (strcmp(def->defname, "streaming_fetch") == 0)
+			set_streaming_fetch(def, fpinfo);
 	}
 }
 
@@ -7066,9 +7440,20 @@ apply_table_options(PgFdwRelationInfo *fpinfo)
 			(void) parse_int(defGetString(def), &fpinfo->fetch_size, 0, NULL);
 		else if (strcmp(def->defname, "async_capable") == 0)
 			fpinfo->async_capable = defGetBoolean(def);
+		else if (strcmp(def->defname, "streaming_fetch") == 0)
+			set_streaming_fetch(def, fpinfo);
 	}
 }
 
+static void
+set_streaming_fetch(DefElem *def, PgFdwRelationInfo *fpinfo)
+{
+	fpinfo->streaming_fetch = defGetBoolean(def);
+	if (fpinfo->streaming_fetch && PQlibVersion() < 170000)
+		ereport(ERROR, errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+				errmsg("streaming_fetch requires libpq version 17 or later"));
+}
+
 /*
  * Merge FDW options from input relations into a new set of options for a join
  * or an upper rel.
@@ -7101,6 +7486,7 @@ merge_fdw_options(PgFdwRelationInfo *fpinfo,
 	fpinfo->use_remote_estimate = fpinfo_o->use_remote_estimate;
 	fpinfo->fetch_size = fpinfo_o->fetch_size;
 	fpinfo->async_capable = fpinfo_o->async_capable;
+	fpinfo->streaming_fetch = fpinfo_o->streaming_fetch;
 
 	/* Merge the table level options from either side of the join. */
 	if (fpinfo_i)
@@ -7132,6 +7518,11 @@ merge_fdw_options(PgFdwRelationInfo *fpinfo,
 		 */
 		fpinfo->async_capable = fpinfo_o->async_capable ||
 			fpinfo_i->async_capable;
+		fpinfo->streaming_fetch = fpinfo_o->streaming_fetch ||
+			fpinfo_i->streaming_fetch;
+		/* streaming_fetch and async execution are mutually exclusive */
+		if (fpinfo->streaming_fetch)
+			fpinfo->async_capable = false;
 	}
 }
 
diff --git a/contrib/postgres_fdw/postgres_fdw.h b/contrib/postgres_fdw/postgres_fdw.h
index a2bb1ff352c..c096c9dddc2 100644
--- a/contrib/postgres_fdw/postgres_fdw.h
+++ b/contrib/postgres_fdw/postgres_fdw.h
@@ -88,6 +88,7 @@ typedef struct PgFdwRelationInfo
 	UserMapping *user;			/* only set in use_remote_estimate mode */
 
 	int			fetch_size;		/* fetch size for this remote table */
+	bool		streaming_fetch;	/* true if cursor-free fetch is enabled */
 
 	/*
 	 * Name of the relation, for use while EXPLAINing ForeignScan.  It is used
@@ -131,12 +132,16 @@ typedef struct PgFdwRelationInfo
 	int			relation_index;
 } PgFdwRelationInfo;
 
+typedef struct PgFdwScanState PgFdwScanState;
+
 /*
  * Extra control information relating to a connection.
  */
 typedef struct PgFdwConnState
 {
 	AsyncRequest *pendingAreq;	/* pending async request */
+	PgFdwScanState *active_scan;	/* last query executed, required for
+									 * non-cursor mode */
 } PgFdwConnState;
 
 /*
@@ -164,8 +169,10 @@ extern unsigned int GetCursorNumber(PGconn *conn);
 extern unsigned int GetPrepStmtNumber(PGconn *conn);
 extern void do_sql_command(PGconn *conn, const char *sql);
 extern PGresult *pgfdw_get_result(PGconn *conn);
+extern PGresult *pgfdw_get_next_result(PGconn *conn);
 extern PGresult *pgfdw_exec_query(PGconn *conn, const char *query,
 								  PgFdwConnState *state);
+extern bool pgfdw_cancel_query(PGconn *conn);
 pg_noreturn extern void pgfdw_report_error(PGresult *res, PGconn *conn,
 										   const char *sql);
 extern void pgfdw_report(int elevel, PGresult *res, PGconn *conn,
